/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20140926-64 [Oct 16 2014]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembly of ssdt6.dat, Tue Nov 25 08:54:44 2014
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000125C (4700)
 *     Revision         0x01
 *     Checksum         0xDE
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "SaSsdt "
 *     OEM Revision     0x00003000 (12288)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120711 (538052369)
 */
DefinitionBlock ("ssdt6.aml", "SSDT", 1, "LENOVO", "SaSsdt ", 0x00003000)
{
    /*
     * iASL Warning: There were 1 external control methods found during
     * disassembly, but additional ACPI tables to resolve these externals
     * were not specified. This resulting disassembler output file may not
     * compile because the disassembler did not know how many arguments
     * to assign to these methods. To specify the tables needed to resolve
     * external control method references, the -e option can be used to
     * specify the filenames. Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (GUAM, MethodObj)    // Warning: Unresolved method, guessing 1 arguments

    External (_SB_.LID_._LID, IntObj)
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.B0D3, DeviceObj)
    External (_SB_.PCI0.LPC_.SCIS, UnknownObj)
    External (_SB_.PCI0.VID_, DeviceObj)
    External (LIDS, UnknownObj)
    External (S0ID, UnknownObj)
    External (WVIS, UnknownObj)
    External (WXPF, UnknownObj)

    OperationRegion (SANV, SystemMemory, 0x7CE40D98, 0x0141)
    Field (SANV, AnyAcc, Lock, Preserve)
    {
        SARV,   32, 
        ASLB,   32, 
        IMON,   8, 
        IGDS,   8, 
        CADL,   8, 
        PADL,   8, 
        CSTE,   16, 
        NSTE,   16, 
        DID9,   32, 
        DIDA,   32, 
        DIDB,   32, 
        IBTT,   8, 
        IPAT,   8, 
        IPSC,   8, 
        IBLC,   8, 
        IBIA,   8, 
        ISSC,   8, 
        IPCF,   8, 
        IDMS,   8, 
        IF1E,   8, 
        HVCO,   8, 
        NXD1,   32, 
        NXD2,   32, 
        NXD3,   32, 
        NXD4,   32, 
        NXD5,   32, 
        NXD6,   32, 
        NXD7,   32, 
        NXD8,   32, 
        GSMI,   8, 
        PAVP,   8, 
        Offset (0x49), 
        KSV0,   32, 
        KSV1,   8, 
        BBAR,   32, 
        BLCS,   8, 
        BRTL,   8, 
        ALSE,   8, 
        ALAF,   8, 
        LLOW,   8, 
        LHIH,   8, 
        ALFP,   8, 
        AUDA,   32, 
        AUDB,   32, 
        Offset (0x65), 
        DIDC,   32, 
        DIDD,   32, 
        DIDE,   32, 
        DIDF,   32, 
        CADR,   32, 
        CCNT,   8, 
        Offset (0xC8), 
        SGMD,   8, 
        SGFL,   8, 
        PWOK,   8, 
        HLRS,   8, 
        PWEN,   8, 
        PRST,   8, 
        CPSP,   32, 
        EECP,   8, 
        EVCP,   16, 
        XBAS,   32, 
        GBAS,   16, 
        SGGP,   8, 
        NVGA,   32, 
        NVHA,   32, 
        AMDA,   32, 
        NDID,   8, 
        DID1,   32, 
        DID2,   32, 
        DID3,   32, 
        DID4,   32, 
        DID5,   32, 
        DID6,   32, 
        DID7,   32, 
        DID8,   32, 
        OBS1,   32, 
        OBS2,   32, 
        OBS3,   32, 
        OBS4,   32, 
        OBS5,   32, 
        OBS6,   32, 
        OBS7,   32, 
        OBS8,   32, 
        LTRA,   8, 
        OBFA,   8, 
        LTRB,   8, 
        OBFB,   8, 
        LTRC,   8, 
        OBFC,   8, 
        SMSL,   16, 
        SNSL,   16, 
        P0UB,   8, 
        P1UB,   8, 
        P2UB,   8, 
        EDPV,   8, 
        NXDX,   32, 
        DIDX,   32, 
        PCSL,   8, 
        SC7A,   8
    }

    Scope (\_SB.PCI0.B0D3)
    {
        Name (BARA, 0x80000000)
        Name (TBAR, Zero)
        Name (TCMD, Zero)
        Name (MODB, Zero)
        Name (MODC, Zero)
        Method (_STA, 0, NotSerialized)  // _STA: Status
        {
            If (LNotEqual (AUVD, 0xFFFF))
            {
                Return (0x0F)
            }

            Return (Zero)
        }

        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            If (LAnd (LNotEqual (And (ABAR, 0xFFFFC004), 0xFFFFC004), 
                LNotEqual (And (ABAR, 0xFFFFC000), Zero)))
            {
                Store (ABAR, BARA) /* \_SB_.PCI0.B0D3.BARA */
            }
        }

        OperationRegion (RPCS, SystemMemory, \XBAS, 0x00018040)
        Field (RPCS, AnyAcc, NoLock, Preserve)
        {
            Offset (0x18004), 
            ACMD,   8, 
            Offset (0x18010), 
            ABAR,   32
        }

        OperationRegion (RPCZ, PCI_Config, Zero, 0x40)
        Field (RPCZ, DWordAcc, Lock, Preserve)
        {
            AUVD,   16
        }

        Method (ASTR, 0, Serialized)
        {
            If (LAnd (LNotEqual (And (ABAR, 0xFFFFC004), 0xFFFFC004), 
                LNotEqual (And (ABAR, 0xFFFFC000), Zero)))
            {
                And (ABAR, 0xFFFFFFF0, BBAR) /* \BBAR */
                Add (BBAR, 0x1000, BBAR) /* \BBAR */
                OperationRegion (RPCY, SystemMemory, BBAR, 0x25)
                Field (RPCY, DWordAcc, NoLock, Preserve)
                {
                    Offset (0x0C), 
                    EM4W,   32, 
                    EMWA,   32, 
                    Offset (0x1C), 
                    ADWA,   32
                }

                Store (AUDA, EMWA) /* \_SB_.PCI0.B0D3.ASTR.EMWA */
                Store (AUDB, ADWA) /* \_SB_.PCI0.B0D3.ASTR.ADWA */
            }
        }

        Method (VSTR, 1, Serialized)
        {
            Name (CONT, 0x03E8)
            Name (ADDR, 0x80000000)
            Store (Arg0, ADDR) /* \_SB_.PCI0.B0D3.VSTR.ADDR */
            OperationRegion (CCDC, SystemMemory, ADDR, 0x04)
            Field (CCDC, ByteAcc, NoLock, Preserve)
            {
                CDEC,   32
            }

            If (LAnd (LNotEqual (And (ABAR, 0xFFFFC004), 0xFFFFC004), 
                LNotEqual (And (ABAR, 0xFFFFC000), Zero)))
            {
                If (LNotEqual (CDEC, Zero))
                {
                    And (ABAR, 0xFFFFFFF0, BBAR) /* \BBAR */
                    OperationRegion (IPCV, SystemMemory, BBAR, 0x70)
                    Field (IPCV, DWordAcc, NoLock, Preserve)
                    {
                        Offset (0x60), 
                        AVIC,   32, 
                        Offset (0x68), 
                        AIRS,   16
                    }

                    Store (0x03E8, CONT) /* \_SB_.PCI0.B0D3.VSTR.CONT */
                    While (LAnd (LEqual (And (AIRS, One), One), LNotEqual (
                        CONT, Zero)))
                    {
                        Stall (One)
                        Decrement (CONT)
                    }

                    Or (AIRS, 0x02, AIRS) /* \_SB_.PCI0.B0D3.VSTR.AIRS */
                    Store (CDEC, AVIC) /* \_SB_.PCI0.B0D3.VSTR.AVIC */
                    Or (AIRS, One, AIRS) /* \_SB_.PCI0.B0D3.VSTR.AIRS */
                    Store (0x03E8, CONT) /* \_SB_.PCI0.B0D3.VSTR.CONT */
                    While (LAnd (LEqual (And (AIRS, One), One), LNotEqual (
                        CONT, Zero)))
                    {
                        Stall (One)
                        Decrement (CONT)
                    }
                }
            }
        }

        Method (CXDC, 0, Serialized)
        {
            Name (IDDX, 0x80000000)
            If (LAnd (LNotEqual (CADR, Zero), LNotEqual (CCNT, Zero)))
            {
                Store (CADR, IDDX) /* \_SB_.PCI0.B0D3.CXDC.IDDX */
                While (LLess (IDDX, Add (CADR, Multiply (CCNT, 0x04))))
                {
                    VSTR (IDDX)
                    Add (IDDX, 0x04, IDDX) /* \_SB_.PCI0.B0D3.CXDC.IDDX */
                }
            }
        }

        Method (ARST, 0, Serialized)
        {
            If (LAnd (LNotEqual (And (ABAR, 0xFFFFC004), 0xFFFFC004), 
                LNotEqual (And (ABAR, 0xFFFFC000), Zero)))
            {
                And (ABAR, 0xFFFFFFF0, BBAR) /* \BBAR */
                OperationRegion (IPCV, SystemMemory, BBAR, 0xBF)
                Field (IPCV, AnyAcc, NoLock, Preserve)
                {
                    Offset (0x08), 
                    CRST,   32, 
                    Offset (0x4C), 
                    CORB,   32, 
                    Offset (0x5C), 
                    RIRB,   32, 
                    Offset (0x80), 
                    OSD1,   32, 
                    Offset (0xA0), 
                    OSD2,   32
                }

                And (CORB, 0xFFFFFFFD, CORB) /* \_SB_.PCI0.B0D3.ARST.CORB */
                And (RIRB, 0xFFFFFFFD, RIRB) /* \_SB_.PCI0.B0D3.ARST.RIRB */
                And (OSD1, 0xFFFFFFFD, OSD1) /* \_SB_.PCI0.B0D3.ARST.OSD1 */
                And (OSD2, 0xFFFFFFFD, OSD2) /* \_SB_.PCI0.B0D3.ARST.OSD2 */
                And (CRST, 0xFFFFFFFE, CRST) /* \_SB_.PCI0.B0D3.ARST.CRST */
            }
        }

        Method (AINI, 0, Serialized)
        {
            Name (CONT, 0x03E8)
            If (LAnd (LNotEqual (And (ABAR, 0xFFFFC004), 0xFFFFC004), 
                LNotEqual (And (ABAR, 0xFFFFC000), Zero)))
            {
                And (ABAR, 0xFFFFFFF0, BBAR) /* \BBAR */
                OperationRegion (IPCV, SystemMemory, BBAR, 0x70)
                Field (IPCV, DWordAcc, NoLock, Preserve)
                {
                    GCAP,   16, 
                    Offset (0x08), 
                    GCTL,   32, 
                    Offset (0x0E), 
                    SSTS,   8, 
                    Offset (0x60), 
                    AVIC,   32, 
                    Offset (0x68), 
                    AIRS,   16
                }

                Or (GCTL, One, GCTL) /* \_SB_.PCI0.B0D3.AINI.GCTL */
                Store (0x03E8, CONT) /* \_SB_.PCI0.B0D3.AINI.CONT */
                While (LAnd (LEqual (And (GCTL, One), Zero), LNotEqual (
                    CONT, Zero)))
                {
                    Stall (One)
                    Decrement (CONT)
                }

                And (GCAP, 0xFFFF, GCAP) /* \_SB_.PCI0.B0D3.AINI.GCAP */
                Or (SSTS, 0x0F, SSTS) /* \_SB_.PCI0.B0D3.AINI.SSTS */
                And (GCTL, 0xFFFFFFFE, GCTL) /* \_SB_.PCI0.B0D3.AINI.GCTL */
                Store (0x03E8, CONT) /* \_SB_.PCI0.B0D3.AINI.CONT */
                While (LAnd (LEqual (And (GCTL, One), One), LNotEqual (
                    CONT, Zero)))
                {
                    Stall (One)
                    Decrement (CONT)
                }

                Or (GCTL, One, GCTL) /* \_SB_.PCI0.B0D3.AINI.GCTL */
                Store (0x03E8, CONT) /* \_SB_.PCI0.B0D3.AINI.CONT */
                While (LAnd (LEqual (And (GCTL, One), Zero), LNotEqual (
                    CONT, Zero)))
                {
                    Stall (One)
                    Decrement (CONT)
                }
            }
        }

        Method (ABWA, 1, Serialized)
        {
            If (Arg0)
            {
                If (LOr (LEqual (And (ABAR, 0xFFFFC004), 0xFFFFC004), LEqual (And (
                    ABAR, 0xFFFFC000), Zero)))
                {
                    If (LNotEqual (BARA, 0x80000000))
                    {
                        Store (ABAR, TBAR) /* \_SB_.PCI0.B0D3.TBAR */
                        Store (ACMD, TCMD) /* \_SB_.PCI0.B0D3.TCMD */
                        Store (BARA, ABAR) /* \_SB_.PCI0.B0D3.ABAR */
                        Store (0x06, ACMD) /* \_SB_.PCI0.B0D3.ACMD */
                        Store (One, MODB) /* \_SB_.PCI0.B0D3.MODB */
                    }
                }
                Else
                {
                    If (LNotEqual (And (ACMD, 0x06), 0x06))
                    {
                        Store (ACMD, TCMD) /* \_SB_.PCI0.B0D3.TCMD */
                        Store (0x06, ACMD) /* \_SB_.PCI0.B0D3.ACMD */
                        Store (One, MODC) /* \_SB_.PCI0.B0D3.MODC */
                    }
                }
            }
            Else
            {
                If (MODB)
                {
                    If (LEqual (ABAR, BARA))
                    {
                        Store (TBAR, ABAR) /* \_SB_.PCI0.B0D3.ABAR */
                        Store (TCMD, ACMD) /* \_SB_.PCI0.B0D3.ACMD */
                    }
                }

                If (MODC)
                {
                    Store (TCMD, ACMD) /* \_SB_.PCI0.B0D3.ACMD */
                }
            }
        }
    }

    Scope (\_SB.PCI0.VID)
    {
        Scope (\_SB.PCI0)
        {
            OperationRegion (MCHP, PCI_Config, 0x40, 0xC0)
            Field (MCHP, AnyAcc, NoLock, Preserve)
            {
                Offset (0x14), 
                AUDE,   8, 
                Offset (0x60), 
                TASM,   10, 
                Offset (0x62)
            }
        }

        OperationRegion (IGDP, PCI_Config, 0x40, 0xC0)
        Field (IGDP, AnyAcc, NoLock, Preserve)
        {
            Offset (0x12), 
                ,   1, 
            GIVD,   1, 
                ,   2, 
            GUMA,   3, 
            Offset (0x14), 
                ,   4, 
            GMFN,   1, 
            Offset (0x18), 
            Offset (0xA4), 
            ASLE,   8, 
            Offset (0xA8), 
            GSSE,   1, 
            GSSB,   14, 
            GSES,   1, 
            Offset (0xB0), 
                ,   12, 
            CDVL,   1, 
            Offset (0xB2), 
            Offset (0xB5), 
            LBPC,   8, 
            Offset (0xBC), 
            ASLS,   32
        }

        OperationRegion (IGDM, SystemMemory, \ASLB, 0x2000)
        Field (IGDM, AnyAcc, NoLock, Preserve)
        {
            SIGN,   128, 
            SIZE,   32, 
            OVER,   32, 
            SVER,   256, 
            VVER,   128, 
            GVER,   128, 
            MBOX,   32, 
            DMOD,   32, 
            PCON,   32, 
            DVER,   64, 
            Offset (0x100), 
            DRDY,   32, 
            CSTS,   32, 
            CEVT,   32, 
            Offset (0x120), 
            DIDL,   32, 
            DDL2,   32, 
            DDL3,   32, 
            DDL4,   32, 
            DDL5,   32, 
            DDL6,   32, 
            DDL7,   32, 
            DDL8,   32, 
            CPDL,   32, 
            CPL2,   32, 
            CPL3,   32, 
            CPL4,   32, 
            CPL5,   32, 
            CPL6,   32, 
            CPL7,   32, 
            CPL8,   32, 
            CADL,   32, 
            CAL2,   32, 
            CAL3,   32, 
            CAL4,   32, 
            CAL5,   32, 
            CAL6,   32, 
            CAL7,   32, 
            CAL8,   32, 
            NADL,   32, 
            NDL2,   32, 
            NDL3,   32, 
            NDL4,   32, 
            NDL5,   32, 
            NDL6,   32, 
            NDL7,   32, 
            NDL8,   32, 
            ASLP,   32, 
            TIDX,   32, 
            CHPD,   32, 
            CLID,   32, 
            CDCK,   32, 
            SXSW,   32, 
            EVTS,   32, 
            CNOT,   32, 
            NRDY,   32, 
            DDL9,   32, 
            DD10,   32, 
            DD11,   32, 
            DD12,   32, 
            DD13,   32, 
            DD14,   32, 
            DD15,   32, 
            CPL9,   32, 
            CP10,   32, 
            CP11,   32, 
            CP12,   32, 
            CP13,   32, 
            CP14,   32, 
            CP15,   32, 
            Offset (0x200), 
            SCIE,   1, 
            GEFC,   4, 
            GXFC,   3, 
            GESF,   8, 
            Offset (0x204), 
            PARM,   32, 
            DSLP,   32, 
            Offset (0x300), 
            ARDY,   32, 
            ASLC,   32, 
            TCHE,   32, 
            ALSI,   32, 
            BCLP,   32, 
            PFIT,   32, 
            CBLV,   32, 
            BCLM,   320, 
            CPFM,   32, 
            EPFM,   32, 
            PLUT,   592, 
            PFMB,   32, 
            CCDV,   32, 
            PCFT,   32, 
            SROT,   32, 
            IUER,   32, 
            FDSP,   64, 
            FDSS,   32, 
            STAT,   32, 
            Offset (0x400), 
            GVD1,   49152, 
            PHED,   32, 
            BDDC,   2048
        }

        Name (DBTB, Package (0x15)
        {
            Zero, 
            0x07, 
            0x38, 
            0x01C0, 
            0x0E00, 
            0x3F, 
            0x01C7, 
            0x0E07, 
            0x01F8, 
            0x0E38, 
            0x0FC0, 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            Zero, 
            0x7000, 
            0x7007, 
            0x7038, 
            0x71C0, 
            0x7E00
        })
        Name (CDCT, Package (0x05)
        {
            Package (0x02)
            {
                0xE4, 
                0x0140
            }, 

            Package (0x02)
            {
                0xDE, 
                0x014D
            }, 

            Package (0x02)
            {
                0xDE, 
                0x014D
            }, 

            Package (0x02)
            {
                Zero, 
                Zero
            }, 

            Package (0x02)
            {
                0xDE, 
                0x014D
            }
        })
        Name (SUCC, One)
        Name (NVLD, 0x02)
        Name (CRIT, 0x04)
        Name (NCRT, 0x06)
        Method (GSCI, 0, Serialized)
        {
            If (LEqual (GEFC, 0x04))
            {
                Store (GBDA (), GXFC) /* \_SB_.PCI0.VID_.GXFC */
            }

            If (LEqual (GEFC, 0x06))
            {
                Store (SBCB (), GXFC) /* \_SB_.PCI0.VID_.GXFC */
            }

            Store (Zero, GEFC) /* \_SB_.PCI0.VID_.GEFC */
            Store (One, \_SB.PCI0.LPC.SCIS) /* External reference */
            Store (Zero, GSSE) /* \_SB_.PCI0.VID_.GSSE */
            Store (Zero, SCIE) /* \_SB_.PCI0.VID_.SCIE */
            Return (Zero)
        }

        Method (GBDA, 0, Serialized)
        {
            If (LEqual (GESF, Zero))
            {
                Store (0x0241, PARM) /* \_SB_.PCI0.VID_.PARM */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, One))
            {
                Store (0x00200382, PARM) /* \_SB_.PCI0.VID_.PARM */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x04))
            {
                And (PARM, 0xEFFF0000, PARM) /* \_SB_.PCI0.VID_.PARM */
                And (PARM, ShiftLeft (DerefOf (Index (DBTB, IBTT)), 0x10), 
                    PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (IBTT, PARM, PARM) /* \_SB_.PCI0.VID_.PARM */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x05))
            {
                If (\_SB.LID._LID)
                {
                    Store (One, LIDS) /* External reference */
                }
                Else
                {
                    Store (Zero, LIDS) /* External reference */
                }

                Store (IPSC, PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (PARM, ShiftLeft (IPAT, 0x08), PARM) /* \_SB_.PCI0.VID_.PARM */
                Add (PARM, 0x0100, PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (PARM, ShiftLeft (LIDS, 0x10), PARM) /* \_SB_.PCI0.VID_.PARM */
                Add (PARM, 0x00010000, PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (PARM, ShiftLeft (IBIA, 0x14), PARM) /* \_SB_.PCI0.VID_.PARM */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x07))
            {
                Store (GIVD, PARM) /* \_SB_.PCI0.VID_.PARM */
                XOr (PARM, One, PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (PARM, ShiftLeft (GMFN, One), PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (PARM, 0x1800, PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (PARM, 0x00060000, PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (PARM, ShiftLeft (IDMS, 0x11), PARM) /* \_SB_.PCI0.VID_.PARM */
                Or (ShiftLeft (DerefOf (Index (DerefOf (Index (CDCT, HVCO)), CDVL
                    )), 0x15), PARM, PARM) /* \_SB_.PCI0.VID_.PARM */
                Store (One, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x0A))
            {
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                If (ISSC)
                {
                    Or (PARM, 0x03, PARM) /* \_SB_.PCI0.VID_.PARM */
                }

                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x0B))
            {
                Store (KSV0, PARM) /* \_SB_.PCI0.VID_.PARM */
                Store (KSV1, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
            Return (CRIT) /* \_SB_.PCI0.VID_.CRIT */
        }

        Method (SBCB, 0, Serialized)
        {
            If (LEqual (GESF, Zero))
            {
                Store (0x00220382, PARM) /* \_SB_.PCI0.VID_.PARM */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, One))
            {
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x03))
            {
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x04))
            {
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x05))
            {
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x07))
            {
                If (LEqual (S0ID, One))
                {
                    If (LEqual (And (PARM, 0xFF), One))
                    {
                        \GUAM (One)
                    }
                }

                If (LEqual (PARM, Zero))
                {
                    Store (CLID, Local0)
                    If (And (0x80000000, Local0))
                    {
                        And (CLID, 0x0F, CLID) /* \_SB_.PCI0.VID_.CLID */
                        GLID (CLID)
                    }
                }

                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x08))
            {
                If (LEqual (S0ID, One))
                {
                    Store (And (ShiftRight (PARM, 0x08), 0xFF), Local0)
                    If (LEqual (Local0, Zero))
                    {
                        \GUAM (Zero)
                    }
                }

                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x09))
            {
                And (PARM, 0xFF, IBTT) /* \IBTT */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x0A))
            {
                And (PARM, 0xFF, IPSC) /* \IPSC */
                If (And (ShiftRight (PARM, 0x08), 0xFF))
                {
                    And (ShiftRight (PARM, 0x08), 0xFF, IPAT) /* \IPAT */
                    Decrement (IPAT)
                }

                And (ShiftRight (PARM, 0x14), 0x07, IBIA) /* \IBIA */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x0B))
            {
                And (ShiftRight (PARM, One), One, IF1E) /* \IF1E */
                If (And (PARM, 0x0001E000))
                {
                    And (ShiftRight (PARM, 0x0D), 0x0F, IDMS) /* \IDMS */
                }
                Else
                {
                    And (ShiftRight (PARM, 0x11), 0x0F, IDMS) /* \IDMS */
                }

                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x10))
            {
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x11))
            {
                Store (ShiftLeft (LIDS, 0x08), PARM) /* \_SB_.PCI0.VID_.PARM */
                Add (PARM, 0x0100, PARM) /* \_SB_.PCI0.VID_.PARM */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x12))
            {
                If (And (PARM, One))
                {
                    If (LEqual (ShiftRight (PARM, One), One))
                    {
                        Store (One, ISSC) /* \ISSC */
                    }
                    Else
                    {
                        Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                        Return (CRIT) /* \_SB_.PCI0.VID_.CRIT */
                    }
                }
                Else
                {
                    Store (Zero, ISSC) /* \ISSC */
                }

                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x13))
            {
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x14))
            {
                And (PARM, 0x0F, PAVP) /* \PAVP */
                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            If (LEqual (GESF, 0x15))
            {
                If (LEqual (PARM, One))
                {
                    Or (\_SB.PCI0.AUDE, 0x20, \_SB.PCI0.AUDE)
                    \_SB.PCI0.B0D3.ABWA (One)
                    \_SB.PCI0.B0D3.ARST ()
                    \_SB.PCI0.B0D3.ASTR ()
                    \_SB.PCI0.B0D3.AINI ()
                    \_SB.PCI0.B0D3.CXDC ()
                    \_SB.PCI0.B0D3.ABWA (Zero)
                    Notify (\_SB.PCI0, Zero) // Bus Check
                }

                If (LEqual (PARM, Zero))
                {
                    And (\_SB.PCI0.AUDE, 0xDF, \_SB.PCI0.AUDE)
                    Notify (\_SB.PCI0, Zero) // Bus Check
                }

                Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
                Store (Zero, PARM) /* \_SB_.PCI0.VID_.PARM */
                Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
            }

            Store (Zero, GESF) /* \_SB_.PCI0.VID_.GESF */
            Return (SUCC) /* \_SB_.PCI0.VID_.SUCC */
        }

        Method (PDRD, 0, NotSerialized)
        {
            If (LNot (DRDY))
            {
                Sleep (ASLP)
            }

            Return (LNot (DRDY))
        }

        Method (PSTS, 0, NotSerialized)
        {
            If (LGreater (CSTS, 0x02))
            {
                Sleep (ASLP)
            }

            Return (LEqual (CSTS, 0x03))
        }

        Method (GNOT, 2, NotSerialized)
        {
            If (PDRD ())
            {
                Return (One)
            }

            Store (Arg0, CEVT) /* \_SB_.PCI0.VID_.CEVT */
            Store (0x03, CSTS) /* \_SB_.PCI0.VID_.CSTS */
            If (LAnd (LEqual (CHPD, Zero), LEqual (Arg1, Zero)))
            {
                If (LNotEqual (Arg0, One))
                {
                    If (LAnd (\WXPF, LNot (\WVIS)))
                    {
                        Notify (\_SB.PCI0, Arg1)
                    }
                    Else
                    {
                        Notify (\_SB.PCI0.VID, Arg1)
                    }
                }
            }

            Notify (\_SB.PCI0.VID, 0x80) // Status Change
            Return (Zero)
        }

        Method (GHDS, 1, NotSerialized)
        {
            Store (Arg0, TIDX) /* \_SB_.PCI0.VID_.TIDX */
            Return (GNOT (One, Zero))
        }

        Method (GLID, 1, NotSerialized)
        {
            Store (Arg0, CLID) /* \_SB_.PCI0.VID_.CLID */
            Return (GNOT (0x02, Zero))
        }

        Method (GLIS, 1, NotSerialized)
        {
            Store (Arg0, CLID) /* \_SB_.PCI0.VID_.CLID */
            Return (Zero)
        }

        Method (GDCK, 1, NotSerialized)
        {
            Store (Arg0, CDCK) /* \_SB_.PCI0.VID_.CDCK */
            Return (GNOT (0x04, 0x80))
        }

        Method (GDCS, 1, NotSerialized)
        {
            Store (Arg0, CDCK) /* \_SB_.PCI0.VID_.CDCK */
        }

        Method (PARD, 0, NotSerialized)
        {
            If (LNot (ARDY))
            {
                Sleep (ASLP)
            }

            Return (LNot (ARDY))
        }

        Method (AINT, 2, NotSerialized)
        {
            If (LNot (And (TCHE, ShiftLeft (One, Arg0))))
            {
                Return (One)
            }

            If (PARD ())
            {
                Return (One)
            }

            If (LEqual (Arg0, 0x02))
            {
                XOr (PFIT, 0x07, PFIT) /* \_SB_.PCI0.VID_.PFIT */
                Or (PFIT, 0x80000000, PFIT) /* \_SB_.PCI0.VID_.PFIT */
                Store (0x04, ASLC) /* \_SB_.PCI0.VID_.ASLC */
            }
            Else
            {
                If (LEqual (Arg0, One))
                {
                    Store (Arg1, BCLP) /* \_SB_.PCI0.VID_.BCLP */
                    Or (BCLP, 0x80000000, BCLP) /* \_SB_.PCI0.VID_.BCLP */
                    Store (0x0A, ASLC) /* \_SB_.PCI0.VID_.ASLC */
                }
                Else
                {
                    If (LEqual (Arg0, 0x03))
                    {
                        Store (Arg1, PFMB) /* \_SB_.PCI0.VID_.PFMB */
                        Or (PFMB, 0x80000100, PFMB) /* \_SB_.PCI0.VID_.PFMB */
                        Store (0x08, ASLC) /* \_SB_.PCI0.VID_.ASLC */
                    }
                    Else
                    {
                        If (LEqual (Arg0, Zero))
                        {
                            Store (Arg1, ALSI) /* \_SB_.PCI0.VID_.ALSI */
                            Store (One, ASLC) /* \_SB_.PCI0.VID_.ASLC */
                        }
                        Else
                        {
                            Return (One)
                        }
                    }
                }
            }

            Store (One, ASLE) /* \_SB_.PCI0.VID_.ASLE */
            Return (Zero)
        }
    }
}

